# {{ ansible_managed }}

version: "3"

services:
  postgres:
    image: "postgres:11-alpine"
    restart: "unless-stopped"
    environment:
      POSTGRES_USER: "postgres"
      POSTGRES_PASSWORD: "benchmark"
      POSTGRES_DB: "benchmark"

  directory-db:
    image: "nlxio/directory-db:{{ nlx_directory_version }}"
    command: ["/usr/local/bin/upgrade-db.sh"]
    restart: "on-failure"
    depends_on:
      - "postgres"
    environment:
      PGHOST: "postgres"
      PGUSER: "postgres"
      PGPASSWORD: "benchmark"
      PGDATABASE: "benchmark"

  directory-inspection-api:
    image: "nlxio/directory-inspection-api:{{ nlx_directory_version }}"
    command: ["/usr/local/bin/nlx-directory-inspection-api"]
    restart: "unless-stopped"
    depends_on:
      - "directory-db"
    ports:
      - "8081:8080"  # http
      - "8091:8443"  # https
    volumes:
      - "{{ nlx_tls_directory }}/root.crt:{{ nlx_tls_directory }}/root.crt:ro"
      - "{{ nlx_tls_directory }}/directory-inspection-api.crt:{{ nlx_tls_directory }}/directory-inspection-api.crt:ro"
      - "{{ nlx_tls_directory }}/directory-inspection-api.key:{{ nlx_tls_directory }}/directory-inspection-api.key:ro"
    environment:
      TLS_NLX_ROOT_CERT: "{{ nlx_tls_directory }}/root.crt"
      TLS_DIRECTORY_CERT: "{{ nlx_tls_directory }}/directory-inspection-api.crt"
      TLS_DIRECTORY_KEY: "{{ nlx_tls_directory }}/directory-inspection-api.key"
      POSTGRES_DSN: "postgres://postgres:benchmark@postgres/benchmark?sslmode=disable"
      DEMO_DOMAIN: "benchmark"
      DEMO_ENV: "benchmark"
      LOG_TYPE: "local"
      LOG_LEVEL: "{{ nlx_directory_log_level }}"

  directory-registration-api:
    image: "nlxio/directory-registration-api:{{ nlx_directory_version }}"
    command: ["/usr/local/bin/nlx-directory-registration-api"]
    restart: "unless-stopped"
    depends_on:
      - "directory-db"
    ports:
      - "8082:8080"  # http
      - "8092:8443"  # https
    volumes:
      - "{{ nlx_tls_directory }}/root.crt:{{ nlx_tls_directory }}/root.crt:ro"
      - "{{ nlx_tls_directory }}/directory-registration-api.crt:{{ nlx_tls_directory }}/directory-registration-api.crt:ro"
      - "{{ nlx_tls_directory }}/directory-registration-api.key:{{ nlx_tls_directory }}/directory-registration-api.key:ro"
    environment:
      TLS_NLX_ROOT_CERT: "{{ nlx_tls_directory }}/root.crt"
      TLS_DIRECTORY_CERT: "{{ nlx_tls_directory }}/directory-registration-api.crt"
      TLS_DIRECTORY_KEY: "{{ nlx_tls_directory }}/directory-registration-api.key"
      POSTGRES_DSN: "postgres://postgres:benchmark@postgres/benchmark?sslmode=disable"
      LOG_TYPE: "local"
      LOG_LEVEL: "{{ nlx_directory_log_level }}"

  directory-monitor:
    image: "nlxio/directory-monitor:{{ nlx_directory_version }}"
    command: ["/usr/local/bin/nlx-directory-monitor"]
    restart: "unless-stopped"
    depends_on:
      - "directory-inspection-api"
    volumes:
      - "{{ nlx_tls_directory }}/root.crt:{{ nlx_tls_directory }}/root.crt:ro"
      - "{{ nlx_tls_directory }}/directory-monitor.crt:{{ nlx_tls_directory }}/directory-monitor.crt:ro"
      - "{{ nlx_tls_directory }}/directory-monitor.key:{{ nlx_tls_directory }}/directory-monitor.key:ro"
    environment:
      TLS_NLX_ROOT_CERT: "{{ nlx_tls_directory }}/root.crt"
      TLS_MONITOR_CERT: "{{ nlx_tls_directory }}/directory-monitor.crt"
      TLS_MONITOR_KEY: "{{ nlx_tls_directory }}/directory-monitor.key"
      TTL_OFFLINE_SERVICE: "1"
      POSTGRES_DSN: "postgres://postgres:benchmark@postgres/benchmark?sslmode=disable"
      LOG_TYPE: "local"
      LOG_LEVEL: "{{ nlx_directory_log_level }}"
    extra_hosts:
      {% for hostname in groups['inway'] -%}
      - "{{ hostname }}:{{ hostvars[hostname].ansible_host }}"
      {% endfor -%}
